VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpcaFocusCh"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' == Caution for use! ==
'
' When you copy a class module in workbook,
' please perform it by Export & Import from Bpca_Focus_V15E.xls by all means.
' (The export file of the class module prepares in the distribution file.)
' If you perform it by Copy & Paste between code windows of VBE,
' Default-property (Item) do not work.

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpcaFocusCh ]
'_/
'_/   --- Breakthrough in the Pseudo-Control-Array --- (Excel2000 or later)
'_/   The class module which provides the Focus Moving detection by Control-Array.
'_/
'_/     << Target Control >>
'_/        ListBox, CommandButton, TextBox, CheckBox
'_/        OptionButton, ToggleButton, ComboBox
'_/        SpinButton, ScrollBar, Frame, MultiPage, TabStrip
'_/
'_/     AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/       [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng3.htm ]
'_/       [http://addinbox.sakura.ne.jp/index.htm]
'_/       [Old Site  http://www.h3.dion.ne.jp/~sakatsu/index.htm]
'_/
'_/     2004/6/1  Ver1.0  1st version(Jpn.)
'_/     2004/6/23 Ver1.1
'_/     2005/3/10 Ver1.2
'_/     2011/4/15 Ver1.3
'_/     2011/9/20 Ver1.4
'_/     2014/7/22 Ver1.5
'_/
'_/     2016/10/4 Ver1.5 English version (1st version)
'_/
'_/  It works in x64.
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

'------[ API for judgments of the key pressing state ]------------------------------
#If VBA7 And Win64 Then
  Private Declare PtrSafe Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
#Else
  Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Long
#End If

'------[ Control definition to acquire an event ]-------------------
Private WithEvents MyCtrlLst As MsForms.ListBox
Attribute MyCtrlLst.VB_VarHelpID = -1
Private WithEvents MyCtrlCmd As MsForms.CommandButton
Attribute MyCtrlCmd.VB_VarHelpID = -1
Private WithEvents MyCtrlTxt As MsForms.TextBox
Attribute MyCtrlTxt.VB_VarHelpID = -1
Private WithEvents MyCtrlChk As MsForms.CheckBox
Attribute MyCtrlChk.VB_VarHelpID = -1
Private WithEvents MyCtrlOpt As MsForms.OptionButton
Attribute MyCtrlOpt.VB_VarHelpID = -1
Private WithEvents MyCtrlTgl As MsForms.ToggleButton
Attribute MyCtrlTgl.VB_VarHelpID = -1
Private WithEvents MyCtrlCbo As MsForms.ComboBox
Attribute MyCtrlCbo.VB_VarHelpID = -1
Private WithEvents MyCtrlSpn As MsForms.SpinButton
Attribute MyCtrlSpn.VB_VarHelpID = -1
Private WithEvents MyCtrlScr As MsForms.ScrollBar
Attribute MyCtrlScr.VB_VarHelpID = -1
Private WithEvents MyCtrlFra As MsForms.Frame
Attribute MyCtrlFra.VB_VarHelpID = -1
Private WithEvents MyCtrlMlt As MsForms.MultiPage
Attribute MyCtrlMlt.VB_VarHelpID = -1
Private WithEvents MyCtrlTab As MsForms.TabStrip
Attribute MyCtrlTab.VB_VarHelpID = -1

Private MyCtrl As Object
Attribute MyCtrl.VB_VarHelpID = -1
Private MyIndex As Integer
Private MyBackColor As Long
Private MyParent As clsBpcaFocus
Private blnParent As Boolean

'===============================================================
Private Sub Class_Initialize()
    blnParent = False
    MyIndex = 0
End Sub

'======== Property / Method definition =============================

'---( Item property )----------------------------
Public Property Let Item(NewCtrl As Object)
    Set MyCtrl = NewCtrl
    MyBackColor = MyCtrl.BackColor  'store initial background color
    
    Select Case TypeName(NewCtrl)
      Case "ListBox": Set MyCtrlLst = NewCtrl
      Case "CommandButton": Set MyCtrlCmd = NewCtrl
      Case "TextBox": Set MyCtrlTxt = NewCtrl
      Case "CheckBox": Set MyCtrlChk = NewCtrl
      Case "OptionButton": Set MyCtrlOpt = NewCtrl
      Case "ToggleButton": Set MyCtrlTgl = NewCtrl
      Case "ComboBox": Set MyCtrlCbo = NewCtrl
      Case "SpinButton": Set MyCtrlSpn = NewCtrl
      Case "ScrollBar": Set MyCtrlScr = NewCtrl
      Case "Frame": Set MyCtrlFra = NewCtrl
      Case "MultiPage": Set MyCtrlMlt = NewCtrl
      Case "TabStrip": Set MyCtrlTab = NewCtrl
    End Select
End Property

Public Property Get Item() As Object
    Set Item = MyCtrl
End Property

'---( Index property)------------------------------------------------
Public Property Let Index(NewIndex As Integer)
    MyIndex = NewIndex
End Property

Public Property Get Index() As Integer
    Index = MyIndex
End Property

'---( InitBColor property )------------------------------------------------
Public Property Get InitBColor() As Long
    InitBColor = MyBackColor
End Property

'---( Parent property )------------------------------------------------
Public Property Let Parent(NewParent As clsBpcaFocus)
    blnParent = True
    Set MyParent = NewParent
End Property

Public Property Get Parent() As clsBpcaFocus
    Set Parent = MyParent
End Property

'---( Clear method )-----------------------------
Public Sub Clear()
    Set MyCtrlLst = Nothing
    Set MyCtrlCmd = Nothing
    Set MyCtrlTxt = Nothing
    Set MyCtrlChk = Nothing
    Set MyCtrlOpt = Nothing
    Set MyCtrlTgl = Nothing
    Set MyCtrlCbo = Nothing
    Set MyCtrlSpn = Nothing
    Set MyCtrlScr = Nothing
    Set MyCtrlFra = Nothing
    Set MyCtrlMlt = Nothing
    Set MyCtrlTab = Nothing

    Set MyCtrl = Nothing
    Set MyParent = Nothing
    blnParent = False
    MyIndex = 0
End Sub

'===================================================================
'===== Event Listener section                     ==================
'===================================================================
' When it receive an event ( KeyDown/KeyUp/MouseDown/MouseUp ),
' it notify Parent-class-object.

Private Sub RaiseFousCheck(ByVal KeyCode As Integer)
    If (blnParent = True) Then
        Select Case KeyCode
          Case 0                        'MouseDown/Up
            MyParent.FocusCheck
            
          Case vbKeyTab, vbKeyReturn        '[Tab][Enter]
            MyParent.FocusCheck
          Case vbKeyLeft To vbKeyDown       '[Left][Right][Up][Down]
            MyParent.FocusCheck
          Case vbKeySeparator               '[Enter] of numeric keypad
            MyParent.FocusCheck
          
          Case Else
            If (GetAsyncKeyState(vbKeyMenu) <> 0) Then
                'Under the pressing of [Alt] key  ==>  Access-Key
                MyParent.FocusCheck
            Else
                'During normal [character input]
            End If
        End Select
    End If
End Sub

'----[ ListBox ]--------------------------------------
Private Sub MyCtrlLst_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlLst_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlLst_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlLst_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ CommandButton ]--------------------------------------
Private Sub MyCtrlCmd_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlCmd_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlCmd_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlCmd_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ TextBox ]--------------------------------------
Private Sub MyCtrlTxt_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlTxt_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlTxt_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlTxt_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ CheckBox ]--------------------------------------
Private Sub MyCtrlChk_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlChk_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlChk_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlChk_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ OptionButtton ]--------------------------------------
Private Sub MyCtrlOpt_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlOpt_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlOpt_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlOpt_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ ToggleButtton ]--------------------------------------
Private Sub MyCtrlTgl_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlTgl_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlTgl_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlTgl_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ ComboBox ]--------------------------------------
Private Sub MyCtrlCbo_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlCbo_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlCbo_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlCbo_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlCbo_DropButtonClick()
    Call RaiseFousCheck(0)
End Sub

'----[ SpinButton ]--------------------------------------
Private Sub MyCtrlSpn_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlSpn_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlSpn_SpinDown()
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlSpn_SpinUp()
    Call RaiseFousCheck(0)
End Sub

'----[ ScrollBar ]--------------------------------------
Private Sub MyCtrlScr_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlScr_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlScr_Scroll()
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlScr_Change()
    Call RaiseFousCheck(0)
End Sub

'----[ Frame ]--------------------------------------
Private Sub MyCtrlFra_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlFra_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlFra_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlFra_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ MultiPage ]--------------------------------------
Private Sub MyCtrlMlt_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlMlt_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlMlt_MouseDown(ByVal Index As Long, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlMlt_MouseUp(ByVal Index As Long, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'----[ TabStrip ]--------------------------------------
Private Sub MyCtrlTab_KeyDown(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlTab_KeyUp(ByVal KeyCode As MsForms.ReturnInteger, ByVal Shift As Integer)
    Call RaiseFousCheck(KeyCode)
End Sub

Private Sub MyCtrlTab_MouseDown(ByVal Index As Long, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

Private Sub MyCtrlTab_MouseUp(ByVal Index As Long, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    Call RaiseFousCheck(0)
End Sub

'=====[AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.]========


